import os
from pathlib import Path
from typing import Literal
from mnrs_exporter import TEMPLATE_DIR


TEST_DIR = Path(os.path.dirname(__file__))
template_path_prefix = os.path.relpath(TEST_DIR, start=TEMPLATE_DIR)

gen_option_output_map = {"addrmap": "testing_addrmap.h",
                         "regfile": ["gen/array_test_regs.h",
                                     "gen/different_size_test_regs.h",
                                     "gen/read_write_test_regs.h",
                                     "gen/field_test_regs.h"],
                         "firmware": ["gen/array_test.h",
                                      "gen/different_size_test.h",
                                      "gen/read_write_test.h",
                                      "gen/field_test.h"],
                         "module_header": ["array_test.h",
                                           "different_size_test.h",
                                           "read_write_test.h",
                                           "field_test.h"],
                         "module_source": ["array_test.cpp",
                                           "different_size_test.cpp",
                                           "read_write_test.cpp",
                                           "field_test.cpp"]
                         }


def check_output(output_dir: Path, gen_option: Literal["addrmap", "regfile", "firmware", "module_header", "module_source"]):
    output = gen_option_output_map[gen_option]
    for file in output if isinstance(output, list) else [output]:
        with open(output_dir/file, encoding="utf8") as generated_file, \
                open(TEST_DIR/"references"/file, encoding="utf8") as reference_file:
            gen_content = generated_file.read()
            ref_content = reference_file.read()
            assert gen_content == ref_content
